#include <iostream>
#define _WIN32_WINNT 0x0501
#include <windows.h>
#define DIRECTINPUT_VERSION 0x0800
#include <dinput.h>
#include "resource.h"

//Direct Input custom data structure
typedef struct g_remote { 
	BYTE bButton[24];
//	DWORD bUnknown;
} g_remote;

DIOBJECTDATAFORMAT g_diodf[] = { 
  { &GUID_Button, FIELD_OFFSET(g_remote, bButton[0]),
    DIDFT_BUTTON | DIDFT_ANYINSTANCE, 0, }, 
  { &GUID_Button, FIELD_OFFSET(g_remote, bButton[1]),
    DIDFT_BUTTON | DIDFT_ANYINSTANCE, 0, }, 
  { &GUID_Button, FIELD_OFFSET(g_remote, bButton[2]),
    DIDFT_BUTTON | DIDFT_ANYINSTANCE, 0, }, 
  { &GUID_Button, FIELD_OFFSET(g_remote, bButton[3]),
    DIDFT_BUTTON | DIDFT_ANYINSTANCE, 0, }, 
  { &GUID_Button, FIELD_OFFSET(g_remote, bButton[4]),
    DIDFT_BUTTON | DIDFT_ANYINSTANCE, 0, }, 
  { &GUID_Button, FIELD_OFFSET(g_remote, bButton[5]),
    DIDFT_BUTTON | DIDFT_ANYINSTANCE, 0, }, 
  { &GUID_Button, FIELD_OFFSET(g_remote, bButton[6]),
    DIDFT_BUTTON | DIDFT_ANYINSTANCE, 0, }, 
  { &GUID_Button, FIELD_OFFSET(g_remote, bButton[7]),
    DIDFT_BUTTON | DIDFT_ANYINSTANCE, 0, }, 
  { &GUID_Button, FIELD_OFFSET(g_remote, bButton[8]),
    DIDFT_BUTTON | DIDFT_ANYINSTANCE, 0, }, 
  { &GUID_Button, FIELD_OFFSET(g_remote, bButton[9]),
    DIDFT_BUTTON | DIDFT_ANYINSTANCE, 0, }, 
  { &GUID_Button, FIELD_OFFSET(g_remote, bButton[10]),
    DIDFT_BUTTON | DIDFT_ANYINSTANCE, 0, }, 
  { &GUID_Button, FIELD_OFFSET(g_remote, bButton[11]),
    DIDFT_BUTTON | DIDFT_ANYINSTANCE, 0, }, 
  { &GUID_Button, FIELD_OFFSET(g_remote, bButton[12]),
    DIDFT_BUTTON | DIDFT_ANYINSTANCE, 0, }, 
  { &GUID_Button, FIELD_OFFSET(g_remote, bButton[13]),
    DIDFT_BUTTON | DIDFT_ANYINSTANCE, 0, }, 
  { &GUID_Button, FIELD_OFFSET(g_remote, bButton[14]),
    DIDFT_BUTTON | DIDFT_ANYINSTANCE, 0, }, 
  { &GUID_Button, FIELD_OFFSET(g_remote, bButton[15]),
    DIDFT_BUTTON | DIDFT_ANYINSTANCE, 0, }, 
  { &GUID_Button, FIELD_OFFSET(g_remote, bButton[16]),
    DIDFT_BUTTON | DIDFT_ANYINSTANCE, 0, }, 
  { &GUID_Button, FIELD_OFFSET(g_remote, bButton[17]),
    DIDFT_BUTTON | DIDFT_ANYINSTANCE, 0, }, 
  { &GUID_Button, FIELD_OFFSET(g_remote, bButton[18]),
    DIDFT_BUTTON | DIDFT_ANYINSTANCE, 0, }, 
  { &GUID_Button, FIELD_OFFSET(g_remote, bButton[19]),
    DIDFT_BUTTON | DIDFT_ANYINSTANCE, 0, }, 
  { &GUID_Button, FIELD_OFFSET(g_remote, bButton[20]),
    DIDFT_BUTTON | DIDFT_ANYINSTANCE, 0, }, 
  { &GUID_Button, FIELD_OFFSET(g_remote, bButton[21]),
    DIDFT_BUTTON | DIDFT_ANYINSTANCE, 0, }, 
  { &GUID_Button, FIELD_OFFSET(g_remote, bButton[22]),
    DIDFT_BUTTON | DIDFT_ANYINSTANCE, 0, }, 
  { &GUID_Button, FIELD_OFFSET(g_remote, bButton[23]),
    DIDFT_BUTTON | DIDFT_ANYINSTANCE, 0, },
//  { &GUID_Unknown, FIELD_OFFSET(g_remote, bUnknown),
//    DIDFT_ALL | DIDFT_ANYINSTANCE, 0, },
};

DIDATAFORMAT g_didf = { 
    sizeof(DIDATAFORMAT),                   // Size of this structure 
    sizeof(DIOBJECTDATAFORMAT),             // Size of object data format 
    DIDF_ABSAXIS,                           // Absolute axis coordinates 
	sizeof(g_remote),                       // Size of device data 
	(sizeof(g_diodf) / sizeof(g_diodf[0])), // Number of objects 
	g_diodf,                                // And here they are 
}; 

//WINAMP API:
struct winampAPI {
	static const unsigned int WA_QUIT = 40001;                //Close Winanp
	static const unsigned int WA_TOGGLEPREF = 40012;          //Toggle preferences screen
	static const unsigned int WA_TOGGLEONTOP = 40019;         //Toggle always on top
	static const unsigned int WA_REPEAT = 40022;              //Toggle Repeat
	static const unsigned int WA_SHUFFLE = 40023;             //Toggle Shuffle
	static const unsigned int WA_FILE_PLAY = 40029;           //Open file dialog
	static const unsigned int WA_TOGGLEEQ = 40036;            //Toggle EQ
	static const unsigned int WA_TIME_REMAINING = 40037;      //Set time display mode to elapsed
	static const unsigned int WA_TIME_ELAPSED = 40038;        //Set time display mode to remaining
	static const unsigned int WA_OPTIONS_PLEDIT = 40040;      //Toggle playlist editor
	static const unsigned int WA_HELP_ABOUT = 40041;          //Toggle about box
	static const unsigned int WA_POPUPMENU = 40043;           //Toggle Popupmenu
	static const unsigned int WA_PREV = 40044;                //Previous track
	static const unsigned int WA_PLAY = 40045;                //Play button
	static const unsigned int WA_PAUSE = 40046;               //Pause/Unpause
	static const unsigned int WA_STOP = 40047;                //Stop button, siehe auch   WA_FADESTOP
	static const unsigned int WA_NEXT = 40048;                //Next track
	static const unsigned int WA_VOLUMEUP = 40058;            //Raise volume by 1%
	static const unsigned int WA_VOLUMEDOWN = 40059;          //Lower volume by 1%
	static const unsigned int WA_FFWDSS = 40060;              //Same function as 40148
	static const unsigned int WA_REW5S = 40061;               //Same function as 40144
	static const unsigned int WA_WNDSHADE = 40064;            //Toggle Windowshade
	static const unsigned int WA_FRW = 40144;                 //Fast-rewind 5 seconds
	static const unsigned int WA_FADESTOP = 40147;            //Fadeout and stop
	static const unsigned int WA_FFW = 40148;                 //Fast-forward 5 seconds
	static const unsigned int WA_PLSTART = 40154;             //Start of playlist
	static const unsigned int WA_OPENURL = 40155;             //Open URL dialog
	static const unsigned int WA_STOPTRACK = 40157;           //Stop after current track
	static const unsigned int WA_DOUBLESIZE = 40165;          //Toggle doublesize mode
	static const unsigned int WA_LOADPRESETS = 40172;         //Opens load presets dialog
	static const unsigned int WA_AUTOLDPRSTS = 40173;         //Opens auto-load presets dialog
	static const unsigned int WA_LOADDEFPRST = 40174;         //Load default preset
	static const unsigned int WA_SAVEPRESET = 40175;          //Opens save preset dialog
	static const unsigned int WA_AUTOLDSAVE = 40176;          //Opens auto-load save preset
	static const unsigned int WA_DELPRESET = 40178;           //Opens delete preset dialog
	static const unsigned int WA_DELAUTOLD = 40180;           //Opens delete an auto load preset dialog
	static const unsigned int WA_SHOWFILEINFO = 40188;        //Open file info box
	static const unsigned int WA_AUTOSCROLL = 40189;          //Toggle title Autoscrolling
	static const unsigned int WA_OPENVISUAL = 40190;          //Open visualization options
	static const unsigned int WA_OPENVIPLUG = 40191;          //Open visualization plug-in options
	static const unsigned int WA_VISUALISATION = 40192;       //Execute current visualization
	static const unsigned int WA_JMP_TO_TIME = 40193;         //Open jump to time dialog
	static const unsigned int WA_JMPFILE = 40194;             //Open jump to file dialog
	static const unsigned int WA_SKINSELEC = 40219;           //Open skin selector
	static const unsigned int WA_CONFVISUAL = 40221;          //Configure current visualization plug-in
	static const unsigned int WA_LOADEQ = 40253;              //Load a preset from EQ
	static const unsigned int WA_SAVEEQ = 40254;              //Save a preset to EQF
	static const unsigned int WA_TOGGLEMW = 40258;            //Toggle main window visible
	static const unsigned int WA_MINIBROWSE = 40298;          //Toggle minibrowser
	static const unsigned int WA_EDBOOKMRK = 40320;           //Show the edit bookmarks
	static const unsigned int WA_BOOKMRKTRK = 40321;          //Adds current track as a bookmark
	static const unsigned int WA_AUDIOCD = 40323;             //Play audio CD
	static const unsigned int WA_MYPLAY = 232323;
} winampAPI;

enum mpcAPI {
	MPC_NIL,
	MPC_PLAYPAUSE,
	MPC_STOP,
	MPC_FULLSCREEN,	
};

/**the message code from the Winamp API are used for Winamp control;
 * messages are send via WM_COMMAND;
 */
bool SendWinampMessage(unsigned int msg) {
	static HWND hwndWinamp;
	static int hwTimestamp = 0;
	int time = GetTickCount();
	if(time - hwTimestamp > 5000) hwndWinamp = NULL;		//dirty, but works

	if(!hwndWinamp) { hwndWinamp = FindWindow(L"Winamp v1.x", NULL); }
	if(!hwndWinamp) { return false; }
	if(msg == winampAPI.WA_MYPLAY)
	{
		LRESULT isPlaying = SendMessage(hwndWinamp, WM_USER, 0, 104);
		if(isPlaying == 0) {
			PostMessage(hwndWinamp, WM_COMMAND, winampAPI.WA_PLAY, 0);
		} else {
			PostMessage(hwndWinamp, WM_COMMAND, winampAPI.WA_PAUSE, 0);
		}
		return true;
	}
	PostMessage(hwndWinamp, WM_COMMAND, msg, 0);
	return true;
}


#ifdef RC__USE_MPC
	//Media Player Classic:
	/**MPC manages to handle most of the keys itself; so we just check
	 * if MPC is running and leave message handling entirely to MPC;
	 */
	bool SendMediaPlayerClassicMessage(mpcAPI msg = MPC_NIL)
	{
		static unsigned int codes = 1;
		/*fullscreen wParam : 98324 lParam : 0
		minimize wParam : 308
		mute wParam : 163 lParam : 0
		next wParam : 332
		pause wParam : 156
		play wParam : 155
		previous wParam : 331
		exit wParam : 65671 lParam : 0
		stop wParam : 158 */
		HWND hwndMPC = FindWindow(L"MediaPlayerClassicW", NULL);
		if(!hwndMPC) { return false; }
		HWND t = GetForegroundWindow();
		if(t != hwndMPC) { return false; }
		return true;
	}
#endif


#ifdef RC__USE_WMP
	/* Windows Media Player:
	84257 Properties
	84313 Copy from CD
	84315 Properties
	84316 Full Mode
	84317 Skin mode
	84318
	84319 Now Playing
	84323 Toggle Media Information
	84325 Toggle Graphic Equalizer
	84326 Toggle Resize Bars
	84327 Toggle Title
	84330 Statics
	84344 Play/Pause
	84345 Stop
	84346 Prev
	84347 Next
	84348 Rew
	84349 Ffd
	84351 Volume Up
	84352 Volume Down
	84353 Mute
	84360 Privacy Statement
	84361 Options
	84362 Help
	84363 Check for update
	84370 Play speed fast
	84371 Play speed normal
	84372 Play speed slow
	84378 Shuffle
	84379 Repeat
	84382 Download Visualizations
	84385 Add to Media Library
	84386 Monitor Folders
	84397 Open
	84398 Open URL
	84407 License Management
	84416 Recent File 1
	84417 Recent File 2
	84418 Recent File 3
	84419 Recent File 4
	84420 Recent File 5
	84421 Recent File 6
	84422 Recent File 7
	84423 Recent File 8
	84424 Recent File 9
	84425 Save As
	84443 Copy To CD
	84445 Copy To Device
	84446 Visualization
	*/
#endif


#ifdef RC__USE_VLC
	//VLC:
	/** note: with the new vlc interface introduced in 0.9.2
	 * a complete enumeration of all top level windows is required
	 * due to the naming convention of qt window classes
	 */
	static HWND VLC_HWND_GLOBAL;
	int CALLBACK VLCWindowEnumCallback(HWND h_vlc, LPARAM lparam) {
		//for each top level window -
		//get window text and check for suffix "VLC media player";
		wchar_t buffer[255];
		GetWindowText(h_vlc, buffer, 255);
		size_t str_len = wcslen(buffer);
		if(str_len < 16) { return 1; }
		wchar_t* str_cmp = (buffer+str_len-16);
		if(wcscmp(str_cmp, L"VLC media player") == 0) {
			GetClassName(h_vlc, buffer, 255);
			//new vlc (0.9.2+): "QWidget"; early versions: "wxWindowClassNR"
			if( (wcscmp(buffer, L"QWidget") != 0) && (wcscmp(buffer, L"wxWindowClassNR") != 0) ) {
				return 1;
			}
			VLC_HWND_GLOBAL = h_vlc;			
		}
		return 1;
	}
	/** the vlc message sender is somewhat dirty; messages are sent via keystroke insertion
	 * to the top level window using SendInput(), which requires some focus switching in 
	 * fullscreen; not pretty, but it seems to work quite well so far;
	 * todo: check for compatibility with vista; eventually replace with a clean key insertion;
	 */
	bool SendVLCMessage(int id) {
		//get window handle:
		VLC_HWND_GLOBAL = 0;
		EnumWindows(VLCWindowEnumCallback, 0);
		if(VLC_HWND_GLOBAL == 0) { return false; }
		HWND h_vlc = VLC_HWND_GLOBAL;

		//check fullscreen:
		HWND h_tmp = GetForegroundWindow();
		wchar_t buffer[128];
		bool fullscreen = false;
		GetClassName(h_tmp, buffer, 128);
		if(wcscmp(buffer, L"VLC DirectX") == 0) {
			//GetWindowText(h_tmp, buffer, 128);
			//if(wcscmp(buffer, "VLC (hardware YUV overlay DirectX output)") == 0) {
				fullscreen = true;
			//}
		}

		tagINPUT in;
 		in.type = INPUT_KEYBOARD;
		in.ki.dwFlags = 0;
		in.ki.time = 0;
		in.ki.dwExtraInfo = 0;
		
		if(h_vlc != h_tmp) {
			SetForegroundWindow(h_vlc);
			Sleep(100);
		}
		//process message:
			switch(id) {
			case 4:   //FFW
				in.ki.dwFlags = KEYEVENTF_UNICODE;
				in.ki.wVk = 0;
				in.ki.wScan = L'+';		//faster
				SendInput(1, (LPINPUT)&in, sizeof(tagINPUT));
				break;
			case 5:   //FBW
				in.ki.dwFlags = KEYEVENTF_UNICODE;
				in.ki.wVk = 0;
				in.ki.wScan = L'-';		//slower
				SendInput(1, (LPINPUT)&in, sizeof(tagINPUT));
				break;
			case 6:   //Info/EPG
				break;
			case 11:  //Stop
				in.ki.dwFlags = KEYEVENTF_UNICODE;
				in.ki.wVk = 0;
				in.ki.wScan = L's';		//stop
				SendInput(1, (LPINPUT)&in, sizeof(tagINPUT));
				break;
			case 13:  //Back
				break;
			case 14:  //PgDown
				in.ki.dwFlags = KEYEVENTF_UNICODE;
				in.ki.wVk = 0;
				in.ki.wScan = L'k';		//subtitle
				SendInput(1, (LPINPUT)&in, sizeof(tagINPUT));
				break;
			case 15:  //PgUp
				in.ki.dwFlags = KEYEVENTF_UNICODE;
				in.ki.wVk = 0;
				in.ki.wScan = L'l';		//audio
				SendInput(1, (LPINPUT)&in, sizeof(tagINPUT));
				break;
			case 16:  //Rec
				in.ki.dwFlags = KEYEVENTF_UNICODE;
				in.ki.wVk = 0;
				in.ki.wScan = L'f';		//fullscreen
				SendInput(1, (LPINPUT)&in, sizeof(tagINPUT));
				fullscreen = false;		//don't bring h_tmp to foreground
				break;
			case 17:  //+
				break;
			case 18:  //-
				break;
			case 19:  //Mute
				break;
			case 20:  //Play
				in.ki.wVk = VK_SPACE;	//play/pause
				SendInput(1, (LPINPUT)&in, sizeof(tagINPUT));
				break;
			case 21:  //FM Radio
				break;
			case 22:  //SkipBW
				in.ki.dwFlags = KEYEVENTF_UNICODE;
				in.ki.wVk = 0;
				in.ki.wScan = L'p';		//previous
				SendInput(1, (LPINPUT)&in, sizeof(tagINPUT));
				break;
			case 23:  //SkipFW
				in.ki.dwFlags = KEYEVENTF_UNICODE;
				in.ki.wVk = 0;
				in.ki.wScan = L'n';		//next
				SendInput(1, (LPINPUT)&in, sizeof(tagINPUT));
				break;
			default:
				SetForegroundWindow(h_tmp);
				return false;
				break;
		}
		if(fullscreen) { SetForegroundWindow(h_tmp); }
		return true;
	}
#endif